<?php // $Id: mysql.php,v 1.1 2007/11/23 23:32:00 krausze Exp $
/**
 * Upgrade procedures for stupla
 *
 * @author
 * @version $Id: mysql.php,v 1.1 2007/11/23 23:32:00 krausze Exp $
 * @package stupla
 **/

/**
 * This function does anything necessary to upgrade
 * older versions to match current functionality
 *
 * @uses $CFG
 * @param int $oldversion The prior version number
 * @return boolean Success/Failure
 **/
function stupla_upgrade($oldversion) {
	global $CFG, $DB;

	if ($oldversion < 2010080601) {
		// new tables and entries
		execute_sql(" ALTER TABLE {$CFG->prefix}stupla ADD subuserdata TEXT AFTER isutf");
		execute_sql(" ALTER TABLE {$CFG->prefix}stupla CHANGE isutf flags int(2)");
		execute_sql(" CREATE TABLE {$CFG->prefix}stupla_session (
			id int(10) unsigned NOT NULL auto_increment,
			stupla int(10) unsigned NOT NULL default '0',
			userid int(10) unsigned NOT NULL default '0',
			data text,
			starttime int(10) unsigned NOT NULL default '0',
			PRIMARY KEY (id),
			KEY stupla_session_stupla_idx (stupla),
			KEY stupla_session_userid_idx (userid)
		) TYPE=MyISAM COMMENT='details about an stupla session';");
		// modify userid to session
		execute_sql(" ALTER TABLE {$CFG->prefix}stupla_action CHANGE userid session int(10)");
		execute_sql(" ALTER TABLE {$CFG->prefix}stupla_ex CHANGE userid session int(10)");
		execute_sql(" ALTER TABLE {$CFG->prefix}stupla_sheet CHANGE userid session int(10)");
		execute_sql(" ALTER TABLE {$CFG->prefix}stupla_plan CHANGE userid session int(10)");
		// fill session
		$actions = $DB->get_records("stupla_action");
		$sessions1 = array();
		foreach ($actions as $action) {
			$key = $action->stupla.'_'.$action->session;
			if ( !array_key_exists($key, $sessions1))
			{
				$sessions1[$key] = array('stupla' => $action->stupla,
									'userid' => $action->session,
									'starttime' => $action->starttime);
				$DB->insert_record("stupla_session", $sessions1[$key]);
			}
		}
		// prepare mapping
		$sessions2 = $DB->get_records('stupla_session', '', '', '', 'id,stupla,userid');
		$sessions3 = array();
		foreach ($sessions2 as $session)
			$sessions3[$session->stupla.'_'.$session->userid] = $session;
		// and perform mapping
		$actions = $DB->get_records('stupla_action', '', '', '', 'id,stupla,session');
		foreach ($actions as $action)
		{
			$action->session = $sessions3[$action->stupla.'_'.$action->session]->id;
			$DB->update_record('stupla_action', $action);
		}
		$exs = $DB->get_records('stupla_ex', '', '', '', 'id,stupla,session');
		foreach ($exs as $ex)
		{
			$ex->session = $sessions3[$ex->stupla.'_'.$ex->session]->id;
			$DB->update_record('stupla_ex', $ex);
		}
		$sheets = $DB->get_records('stupla_sheet', '', '', '', 'id,stupla,session');
		foreach ($sheets as $sheet)
		{
			$sheet->session = $sessions3[$sheet->stupla.'_'.$sheet->session]->id;
			$DB->update_record('stupla_sheet', $sheet);
		}
		$plans = $DB->get_records('stupla_plan', '', '', '', 'id,stupla,session');
		foreach ($plans as $plan)
		{
			$plan->session = $sessions3[$plan->stupla.'_'.$plan->session]->id;
			$DB->update_record('stupla_plan', $plan);
		}
	}

	if ($oldversion < 2010082601) {
		// new tables and entries
		execute_sql(" ALTER TABLE {$CFG->prefix}stupla ADD localpath varchar(255) AFTER reference");
	}

	if ($oldversion < 2010092701) {
		// new tables and entries
		execute_sql(" ALTER TABLE {$CFG->prefix}stupla ADD subuserprotname varchar(255) AFTER subuserdata");
	}
	return true;
}

?>
