#
# Table structure for table `stupla`
#
CREATE TABLE prefix_stupla (
    id int(10) unsigned NOT NULL auto_increment,
    course int(10) unsigned NOT NULL default '0',
    name varchar(255) NOT NULL default '',
    summary text NOT NULL default '',
    timeopen int(10) unsigned NOT NULL default '0',
    timeclose int(10) unsigned NOT NULL default '0',
    location int(4) unsigned NOT NULL default '0',
    reference varchar(255) NOT NULL default '',
    localpath varchar(255) NOT NULL default '',
    password varchar(255) NOT NULL default '',
    subnet varchar(255) NOT NULL default '',
    timecreated int(10) unsigned NOT NULL default '0',
    timemodified int(10) unsigned NOT NULL default '0',
    flags tinyint(2) unsigned NOT NULL default '0',
    subuserdata text,
    PRIMARY KEY (id)
) TYPE=MyISAM COMMENT='details about stupla instance';
#
# Table structure for table `stupla_action`
#
CREATE TABLE prefix_stupla_action (
    id int(10) unsigned NOT NULL auto_increment,
    stupla int(10) unsigned NOT NULL default '0',
    session int(10) unsigned NOT NULL default '0',
    starttime int(10) unsigned NOT NULL default '0',
    media int(6) signed NOT NULL default '-99',
    topic int(6) signed NOT NULL default '-99',
    nr int(6) signed NOT NULL default '-99',
    timestamp int(10) unsigned NOT NULL default '0',
    duration int(10) unsigned NOT NULL default '0',
    result int(6),
    data text,
    PRIMARY KEY (id),
    KEY stupla_action_stupla_idx (stupla),
    KEY stupla_action_session_idx (session)
) TYPE=MyISAM COMMENT='details about stupla action';
#
# Table structure for table `stupla_ex`
#
CREATE TABLE prefix_stupla_ex (
    id int(10) unsigned NOT NULL auto_increment,
    stupla int(10) unsigned NOT NULL default '0',
    session int(10) unsigned NOT NULL default '0',
    starttime int(10) unsigned NOT NULL default '0',
    media int(6) signed NOT NULL default '-99',
    topic int(6) signed NOT NULL default '-99',
    nr int(6) signed NOT NULL default '-99',
    ex text,
    PRIMARY KEY (id),
    KEY stupla_marknote_stupla_idx (stupla),
    KEY stupla_marknote_session_idx (session)
) TYPE=MyISAM COMMENT='details about stupla exercises for load';
#
# Table structure for table `stupla_sheet`
#
CREATE TABLE prefix_stupla_sheet (
    id int(10) unsigned NOT NULL auto_increment,
    stupla int(10) unsigned NOT NULL default '0',
    session int(10) unsigned NOT NULL default '0',
    starttime int(10) unsigned NOT NULL default '0',
    sheet text,
    PRIMARY KEY (id),
    KEY stupla_marknote_stupla_idx (stupla),
    KEY stupla_marknote_session_idx (session)
) TYPE=MyISAM COMMENT='details about stupla sheets for load';
#
# Table structure for table `stupla_plan`
#
CREATE TABLE prefix_stupla_plan (
    id int(10) unsigned NOT NULL auto_increment,
    stupla int(10) unsigned NOT NULL default '0',
    session int(10) unsigned NOT NULL default '0',
    starttime int(10) unsigned NOT NULL default '0',
    plan text,
    PRIMARY KEY (id),
    KEY stupla_marknote_stupla_idx (stupla),
    KEY stupla_marknote_session_idx (session)
) TYPE=MyISAM COMMENT='details about stupla plans for load';
#
# Table structure for table `stupla_session`
#
CREATE TABLE prefix_stupla_session (
	id int(10) unsigned NOT NULL auto_increment,
	stupla int(10) unsigned NOT NULL default '0',
	userid int(10) unsigned NOT NULL default '0',
	data text,
	starttime int(10) unsigned NOT NULL default '0',
	PRIMARY KEY (id),
	KEY stupla_session_stupla_idx (stupla),
	KEY stupla_session_userid_idx (userid)
) TYPE=MyISAM COMMENT='details about an stupla session';