<?php

// Allgemeine Daten Uebernahme
require_once("../../../config.php");
require_once("../lib.php");

$id = optional_param('id', 0, PARAM_INT); // Course Module ID, or
$n  = optional_param('n', optional_param('stupla', 0, PARAM_INT), PARAM_INT);  // stupla ID

$sessionid = optional_param('session', 0, PARAM_INT);

if ($id) {
    $cm      = get_coursemodule_from_id('stupla', $id, 0, false, MUST_EXIST);
    $course  = $DB->get_record('course', array('id' => $cm->course), '*', MUST_EXIST);
    $stupla  = $DB->get_record('stupla', array('id' => $cm->instance), '*', MUST_EXIST);
} elseif ($n) {
    $stupla  = $DB->get_record('stupla', array('id' => $n), '*', MUST_EXIST);
    $course  = $DB->get_record('course', array('id' => $stupla->course), '*', MUST_EXIST);
    $cm      = get_coursemodule_from_instance('stupla', $stupla->id, $course->id, false, MUST_EXIST);
} else {
    error('You must specify a course_module ID or an instance ID');
}

$format = optional_param('format', 'showashtml', PARAM_ALPHA);
$sortinfo = optional_param('sortinfo', '', PARAM_TEXT);

require_login($course->id);
$coursecontext = @get_context_instance(CONTEXT_COURSE, $course->id);

if ( ($stupla->flags & STUPLA_USESUBUSERS) )
	stupla_expand_subuserdata($stupla);

// Funktionen

function Sec2Str($s)
{
  if ( $s < 60 )
    return "<font color=\"#808080\">".$s." sec.</font>";
  $min = floor($s/60);
  $s = $s % 60;
  if ( $s < 10 )
    $s = "0".$s;
  if ( $min < 60 )
    return "".$min.":".$s." min.";
  $h = floor($min/60);
  $min = $min % 60;
  if ( $min < 10 )
    $min = "0".$min;
  return "<B>".$h.":".$min.":".$s."h</B>";
}

function GetStudies()
{
  global $stupla;
  $res = array();
	array_push($res, $stupla);
  return $res;
}

$activeClause = ' AND l.flags = 0';

function GetSessions($stu, $sessionid = '') // wenn study == "", dann ueber alle Studies
{
	global $CFG, $USER, $DB, $coursecontext, $activeClause;
	$addUserLimit = ' AND u.id = -42'; // no one
	if ( has_capability('mod/stupla:reviewallprotocols', $coursecontext) )
		$addUserLimit = ''; // all
	else if ( has_capability('mod/stupla:reviewmyprotocols', $coursecontext) )
		$addUserLimit = ' AND u.id = '.$USER->id; // own only
	$addSessionidLimit = $sessionid == '' ? '' : ' AND l.id = '.$sessionid;
/*	if ( function_exists("sql_primary_role_subselect") ) {
		$primary_roles = sql_primary_role_subselect();
		$sql = 'SELECT DISTINCT l.id as id, prs.userid as userid, u.firstname, u.lastname, u.idnumber, l.data, l.starttime FROM ('.$primary_roles.') prs'
				.' JOIN '.$CFG->prefix.'user u ON u.id = prs.userid JOIN '.$CFG->prefix.'stupla_session l ON prs.userid = l.userid '
						.' WHERE l.stupla = '.$stu->id.$addUserLimit
						.$addSessionidLimit.$activeClause
						.' ORDER BY u.lastname, u.firstname';
	}
	else {*/
		$sql = 'SELECT DISTINCT l.id as id, u.id as userid, u.firstname,u.lastname, u.idnumber, l.data, l.starttime FROM '.$CFG->prefix.'user u JOIN '.$CFG->prefix.'stupla_session l ON u.id = l.userid '
						.' WHERE l.stupla = '.$stu->id.$addUserLimit
						.$addSessionidLimit.$activeClause
						.' ORDER BY u.lastname, u.firstname';
	/*}*/
	if (!$sessions = $DB->get_records_sql($sql)) {
		die("SQL(getUsers): ".mysql_error()." ".$sql);
		$sessions = array(); // tablelib will handle saying 'Nothing to display' for us.
	}
	// make displayname
	foreach ($sessions as $id => $session)
	{
		if ( ($stu->flags & STUPLA_USESUBUSERS) && isset($stu->subuserprotname) && isset($session->data))
		{
			$s = $stu->subuserprotname;
			$s = str_replace('$USER$', $session->firstname.' '.$session->lastname, $s);
			$s = str_replace('$SESSION$', $session->id, $s);
			$d = explode("\x01", $session->data);
			foreach($stu->sudata as $fieldId => $field)
				$s = str_replace('$'.$field['name'].'$', $d[$fieldId], $s);
			$sessions[$id]->displayname = $s;
		}
		else
			$sessions[$id]->displayname = $session->firstname.' '.$session->lastname.' ('.$session->id.')';
	}
	return $sessions;
}

function GetSession($sessionid, $stupla = '') // wenn study == "", dann �ber alle Studies
{
/*	global $CFG;
	if ( function_exists("sql_primary_role_subselect") ) {
  	$primary_roles = sql_primary_role_subselect();
	  $sql = 'SELECT DISTINCT prs.userid as id, u.firstname,u.lastname,u.idnumber FROM ('.$primary_roles.') prs'
            .' JOIN '.$CFG->prefix.'user u ON u.id = prs.userid'
            .' WHERE u.id = '.$userid;
	}
	else {
	  $sql = 'SELECT DISTINCT u.id, u.firstname,u.lastname,u.idnumber FROM '.$CFG->prefix.'user u'
            .' WHERE u.id = '.$userid;
	}
 	if (!$user = get_record_sql($sql)) {
    die("SQL(getUser): ".mysql_error());
    $users = array(); // tablelib will handle saying 'Nothing to display' for us.
  }
	return $user;*/
	$sessions = GetSessions($stupla, $sessionid);
	foreach ($sessions as $session)
	{
		if ( $session->id == $sessionid )
			return $session;
	}
	return null;
}

// for call backs
function GetUserPath($study)
{
  global $adapt;
  return $adapt[$study]["UserPath"];
}

// f�r Hist
$TextVisited = array();
$FBRequestCount = 0;
$TotalTime = 0;
$LoginCount = 0;

function ClearHist()
{
	global $TextVisited, $Name, $MediaTitle, $Media, $FBRequestCount, $LoginCount, $TotalTime, $M_AUFGABE;
	// topics
	$TextVisited = array();
	for ($i = 0; $i < count($Name); $i++)
		$TextVisited[$i] = 0;
	// logins
	$LoginCount = 0;
	// Medias
	for ($m = 0 ; $m < count($MediaTitle); $m++)
		for ($i = 0; $i < count($Name); $i++)
			if ( array_key_exists($i, $Media[$m]) && array_key_exists(0, $Media[$m][$i]) && count($Media[$m][$i]) )
				for ($j = 0; $j < count($Media[$m][$i]); $j++)
				{
					$Media[$m][$i][$j][3] = -3;
					if ( $m == $M_AUFGABE )
					{
						unset($Media[$m][$i][$j][4]);
						unset($Media[$m][$i][$j][5]);
					}
				}
	// FB's
	$FBRequestCount = 0;
	// GesamtZeit
	$TotalTime = 0;
}

function ReadHist($session, $stupla, $firstglance = false)
{
	global $DB, $adapt, $TextVisited, $Name, $MediaTitle, $Media, $FBRequestCount, $LoginCount, $TotalTime, $sError, $M_AUFGABE;
	$topicTreshold = -1; // for firstglance
	$topicMax = -1; // for firstglance
	if ($records = $DB->get_records_select("stupla_action", "stupla='$stupla->id' AND session='$session->id'", null, "starttime ASC", "*"))
		foreach ($records as $a) {
			if ( $a->media == STUPLA_LOGIN )
			{
				$LoginCount++;
				if ( $firstglance )
					$topicTreshold = $topicMax;
			}
//    	else if ( $arr[1] == "#fbrequest" )
//      	$FBRequestCount++;
			else if ( $a->topic != -99 && $a->topic > $topicTreshold )
			{
				if ( $a->topic > $topicMax )
					$topicMax = $a->topic;
				$TotalTime += $a->duration;
				$Mode = $a->media;
      	if ( $Mode == 100 )
      	{
        	if ( $a->topic >= 0 )
          	$TextVisited[$a->topic] += $a->duration;
      	}
      	else if ( $a->media == $M_AUFGABE )
      	{
        	if ( array_key_exists($Mode, $Media) && array_key_exists($a->topic, $Media[$Mode]) && array_key_exists($a->nr, $Media[$Mode][$a->topic]) )
          	{
          		$Media[$Mode][$a->topic][$a->nr][3] = round($a->result, 2);
          	 	$Media[$Mode][$a->topic][$a->nr][4] = isset($a->data) ? $a->data : ''; // [4] the exercise filed entries
          	 	if ( !isset($Media[$Mode][$a->topic][$a->nr][5]) ) // [5] the time in exercise
          	 		$Media[$Mode][$a->topic][$a->nr][5] = 0;
          	 	$Media[$Mode][$a->topic][$a->nr][5] += $a->duration;
          	}

      	}
      	else if ( $Mode < 100 )
        	if ( array_key_exists($Mode, $Media) && array_key_exists($a->topic, $Media[$Mode]) && array_key_exists($a->nr, $Media[$Mode][$a->topic]) ) {
          		if ( $Media[$Mode][$a->topic][$a->nr][3] == -3 )
          			$Media[$Mode][$a->topic][$a->nr][3] = 0;
          		$Media[$Mode][$a->topic][$a->nr][3] += $a->duration;
        	}
        	else
          	$sError .= "<BR>ERROR: Aktion f�r Media[".$Mode."][".$a->topic."][".$a->nr."] bei session: ".$session->id." in ".$stupla->id;
    	}
  	}
  return true;
}

/**
 * Summary of currently loaded session.
 * @return array with nLogins, nFbReqs, nTexts, tTexts, nMedia, exercises, time total
 */
function SummaryHist($asHtml) {
    global $adapt, $TextVisited, $Name, $MediaTitle, $Media, $FBRequestCount, $LoginCount, $TotalTime, $sError, $M_AUFGABE;
    $res = array($LoginCount, $FBRequestCount);
    $nTextVisited = 0;
    $timeTextVisited = 0;
    for ($i = 0; $i < count($Name); $i++) {
        if ( $TextVisited[$i] != 0 )
            $nTextVisited++;
        $timeTextVisited += $TextVisited[$i];
    }
    array_push($res, $nTextVisited, $asHtml ? Sec2Str($timeTextVisited) : $timeTextVisited);
    $nExOK = 0;
    $nExWr = 0;
    $nExUn = 0;
    $nMedia = 0;
    for ($m = 0 ; $m < count($MediaTitle); $m++) {
        for ($i = 0; $i < count($Name); $i++) {
            if ( array_key_exists($i, $Media[$m]) && array_key_exists(0, $Media[$m][$i]) && count($Media[$m][$i]) ) {
                for ($j = 0; $j < count($Media[$m][$i]); $j++) {
                    $v = $Media[$m][$i][$j][3];
                    if ( $m != $M_AUFGABE )
                        $nMedia += ( $v != -3 ) ? 1 : 0;
                    else if ( $v < -1 )
                        $nExUn++;
                    else if ( $v >= 99 )
                        $nExOK++;
                    else
                        $nExWr++;
                }
            }
        }
    }
    array_push($res, $nMedia, $asHtml ? '<font color="#006600">'.$nExOK.
         '</font>/<font color="#CC3300">'.$nExWr.
         '</font>/<font color="#3333CC">'.$nExUn.'</font>' : $nExOK.' / '.$nExWr.' / '.$nExUn,
         $asHtml ? Sec2Str($TotalTime) : $TotalTime);
    return $res;
}

// ExerciseList

$ExEntry = array();

function MakeExerciseList($stupla, $sessions)
{
  global $ExEntry, $Name, $M_AUFGABE, $Media;
  // Feld leeren
  for ($topic = 0; $topic < count($Name); $topic++)
    if ( array_key_exists($topic, $Media[$M_AUFGABE]) )
    {
      $ExEntry[$topic] = array();
      for ($i = 0; $i < count($Media[$M_AUFGABE][$topic]); $i++)
        $ExEntry[$topic][$i] = array(array(), array());
    }
  // Daten lesen
  foreach ($sessions as $session)
    ReadExerciseHist($session, $stupla);
}

function ReadExerciseHist($session, $stupla)
{
	global $DB, $adapt, $M_AUFGABE, $Media;
	if ($records = $DB->get_records_select("stupla_action", "stupla='$stupla->id' AND session='$session->id' AND (media = $M_AUFGABE OR media = ".STUPLA_SYSTERROR.")", null, "starttime ASC", "*"))
		foreach ($records as $r)
		{
			if ( $r->media == STUPLA_SYSTERROR )
				AddExEntryAt($r->topic, $r->nr, 1, $arr[3], $arr[6]); //TODO was sind die restlichen Werte?
			else
			{
				if ( array_key_exists($M_AUFGABE, $Media) && array_key_exists($r->topic, $Media[$M_AUFGABE]) && array_key_exists($r->nr, $Media[$M_AUFGABE][$r->topic]) )
					AddExEntry($r->topic, $r->nr, 0, isset($r->data) ? $r->data : "");
			}
		}
	return true;
}

function AddExEntry($topic, $i, $kind, $s)
{
  $arr = explode("|", $s);
  for ($j = 0; $j < count($arr); $j++)
    if ( $arr[$j] != "" )
      AddExEntryAt($topic, $i, $kind, $j, $arr[$j]);
}

function AddExEntryAt($topic, $i, $kind, $j, $s)
{
  global $ExEntry;
  if ( !array_key_exists($j, $ExEntry[$topic][$i][$kind]) )
    $ExEntry[$topic][$i][$kind][$j] = array();
  $done = false;
  $k = 0;
  for ($k = 0; $k < count($ExEntry[$topic][$i][$kind][$j]); $k++)
    if ( $ExEntry[$topic][$i][$kind][$j][$k][1] == $s ) {
      $ExEntry[$topic][$i][$kind][$j][$k][0]++;
      $done = true;
      break;
    }
  if ( $done == false )
     $ExEntry[$topic][$i][$kind][$j][$k] = array(1, $s);
}

/*
// ExerciseList f�r ExCont (jeder Nutzer nur einmal und mit seinem besten Wert)

function MakeExerciseListStrict(study, ExTopic, ExI)
{
  // Feld leeren
  ExEntry = new Array(new Array(), new Array());
  // Daten lesen
  for (var i = 0; i < User.length; i++)
    ReadExerciseHistStrict(User[i], study, ''+M_AUFGABE+'.'+ExTopic+'.'+ExI);
}

function ReadExerciseHistStrict(user, study, ExId)
{
  if ( !fs.FileExists(Server.MapPath(UserPath+user+"_"+study+"_prot.txt")) )
    return false;
  var f=fs.OpenTextFile(Server.MapPath(UserPath+user+"_"+study+"_prot.txt"), 1);
  var vMax = -3;
  var sMaxVal;
  while ( f.AtEndOfStream == false )
  {
    var arr = f.ReadLine().split(' ');
    if ( arr.length < 2 )
      continue;
    if ( arr[1] == "#systerror" && arr2 == ExId) {
      var arr2 = arr[2].split('.');
      AddExEntryAtStrict(1, arr[3], arr[6]);
    }
    else if ( arr[1].charAt(0) != '#' )
    {
      var arr1 = arr[1].split('&');
      if ( arr1[0] == ExId )
        if ( Number(arr1[3]) > vMax )
        {
          vMax = Number(arr1[3]);
          sMaxVal = arr.length > 2 ? arr[2] : "";
        }
    }
  }
  f.Close();
  f=0;
  if ( vMax != -3 )
    AddExEntryStrict(0, sMaxVal);
  return true;
}

function AddExEntryStrict(kind, s)
{
  var arr = s.split('|');
  for (var j = 0; j < arr.length; j++)
    if ( arr[j] != "" )
      AddExEntryAtStrict(kind, j, arr[j]);
}

function AddExEntryAtStrict(kind, j, s)
{
  if ( !ExEntry[kind][j] )
    ExEntry[kind][j] = new Array();
  var done = false;
  var k = 0;
  for (k = 0; k < ExEntry[kind][j].length; k++)
    if ( ExEntry[kind][j][k][1] == s ) {
      ExEntry[kind][j][k][0]++;
      done = true;
      break;
    }
  if ( done == false )
     ExEntry[kind][j][k] = new Array(1, s);
}
*/
// DiagrammGrafik -----------------------------

function DiagramHist($l, $b, $iShort, $rightScale)
{
  global $Name, $nBlock, $Media, $M_AUFGABE, $BlockName, $indexBlock;
  $s = '<table border="0" bgcolor="#DCDCDC"><tr><td><table border=0 cellpadding=2 width="100%"><tr>';
  // Skale
  $s .= '<td align="right" valign="bottom" style="white-space:nowrap" width="39">'.
    '<NOBR><img src="col/ps_100.gif" height="11" width="30"><img src="col/ps_t.gif" height="11" width="5"></NOBR><br>'.
    '<img src="col/ps_line.gif" width="5" height="'.($l/4-11).'"><br>'.
    '<img src="col/ps_75.gif" height="11" width="26"><img src="col/ps_m.gif" height="11" width="5"><br>'.
    '<img src="col/ps_line.gif" width="5" height="'.($l/4-11).'"><br>'.
    '<img src="col/ps_50.gif" height="11" width="26"><img src="col/ps_m.gif" height="11" width="5"><br>'.
    '<img src="col/ps_line.gif" width="5" height="'.($l/4-11).'"><br>'.
    '<img src="col/ps_25.gif" height="11" width="26"><img src="col/ps_m.gif" height="11" width="5"><br>'.
    '<img src="col/ps_line.gif" width="5" height="'.($l/4-11).'"><br>'.
    '<img src="col/ps_b.gif" width="5" height="6">'.
    '</td>';
  $BlockVals = array();
  for ($i = 0; $i < $nBlock; $i++)
    $BlockVals[$i] = array(0, 0, 0);
  for ($i = 0; $i < count($Name); $i++)
    if ( array_key_exists($i, $Media[$M_AUFGABE]) )
      for ($k = 0; $k < count($Media[$M_AUFGABE][$i]); $k++)
      {
        $bl = $Media[$M_AUFGABE][$i][$k][$indexBlock];
        if ( $bl == -1 )
          continue;
        if ( $Media[$M_AUFGABE][$i][$k][3] == -3 )
          $BlockVals[$bl][2]++;
        else if ( $Media[$M_AUFGABE][$i][$k][3] >= 98 )
          $BlockVals[$bl][0]++;
        else
          $BlockVals[$bl][1]++;
      }
  $SummVals = array(0, 0, 0);
  // Bl�cke drucken
  for ($i = 0; $i < $nBlock; $i++)
  {
    $s .= '<td width="'.(100/($nBlock+1)).'%" valign="bottom">';
    $s .= ProtPillar($BlockVals[$i], $l, $b);
    $s .= '</td>';
    $SummVals[0] += $BlockVals[$i][0];
    $SummVals[1] += $BlockVals[$i][1];
    $SummVals[2] += $BlockVals[$i][2];
  }
  $s .= '<td width="'.(100/($nBlock+1)).'%" valign="bottom">';
  $s .= ProtPillar($SummVals, $l, $b);
  // Skale
  $s .= '</td>';
  if ( $rightScale )
    $s .=
    '<td align="left" valign="bottom" style="white-space:nowrap">'.
    '<img src="col/ps_t.gif" height="11" width="5"><img src="col/ps_100.gif" height="11" width="30"><br>'.
    '<img src="col/ps_line.gif" width="5" height="'.($l/4-11).'"><br>'.
    '<img src="col/ps_m.gif" height="11" width="5"><img src="col/ps_75.gif" height="11" width="26"><br>'.
    '<img src="col/ps_line.gif" width="5" height="'.($l/4-11).'"><br>'.
    '<img src="col/ps_m.gif" height="11" width="5"><img src="col/ps_50.gif" height="11" width="26"><br>'.
    '<img src="col/ps_line.gif" width="5" height="'.($l/4-11).'"><br>'.
    '<img src="col/ps_m.gif" height="11" width="5"><img src="col/ps_25.gif" height="11" width="26"><br>'.
    '<img src="col/ps_line.gif" width="5" height="'.($l/4-11).'"><br>'.
    '<img src="col/ps_b.gif" width="5" height="6">'.
    '</td>';
  $s .= '</tr><tr><td>&nbsp;</td>';
  for ($i = 0; $i < $nBlock; $i++)
    $s .= '<td width="'.(100/($nBlock+1)).'%" valign="top" bgcolor="#FFFF80" title="'.$BlockName[$i].'">'.
         Short($BlockName[$i], $iShort).'</td>';
  $s .= '<td valign="top" bgcolor="#FFFF80"><font face="Arial"><strong>ges.</strong></font></td>'.
       ($rightScale ? '<td>&nbsp;</td>' : '').'</tr></table></td></tr></table>';
/*    '<table border="0" cellpadding="3"><tr>\r\n',
    '<td><img src="'col/pc_gruen.gif" width="20" height="20"></td>\r\n',
    '<td><font face="Arial">Richtig gel&ouml;ste Aufgaben.</font></td>\r\n',
    '</tr><tr>\r\n',
    '<td><img src="'col/pc_rot.gif" width="20" height="20"></td>\r\n',
    '<td><font face="Arial">Falsch gel&ouml;ste Aufgaben.</font></td>\r\n',
    '</tr><tr>\r\n',
    '<td><img src="'col/pc_blau.gif" width="20" height="20"></td>\r\n',
    '<td><font face="Arial">Noch nicht bearbeitete Aufgaben.</font></td>\r\n',
    '</tr></table></body></HTML>'*/;
  return $s;
}

function ProtPillar($vals, $l, $b)
{
  $s = "";
  $first = 1;
  $sumAll = 0;
  for ($i = 0; $i < count($vals); $i++)
    $sumAll += $vals[$i];
  $cName = array("gruen", "rot", "blau");
  $cComment = array("richtig gel�st", "falsch gel�st", "unbearbeitet");
  $pix = 0;
  $sum = 0;
  $s .= '<TABLE border="0" cellspacing="0" width="'.($b+8).'"><TR><TD align="left" valign="top" width="40">';
  for ($i = count($vals)-1; $i >= 0; $i--)
    if ( $vals[$i] != 0)
    {
      $sum += $vals[$i];
      $sumPix = round($sum*$l/$sumAll);
      $s .= (($first == 1 ) ? "" : "<br>").
        '<img src="col/pc_'.$cName[$i].'.gif" width="'.$b.'" height="'.($sumPix-$pix).'" alt="'.$vals[$i].
        (($vals[$i] == 1) ? ' Aufgabe ' : ' Aufgaben ') .$cComment[$i].'">';
      $first = 0;
      $pix = $sumPix;
    }
  return $s.'</TD></TR></TABLE>';
}

function Short($s, $iShort)
{
  return strlen($s) < $iShort+1 ? $s : substr($s, 0, $iShort)."..";
}

function CollectExStatus($indexCollect)
{
  global $Name, $Media, $M_AUFGABE;
  for ($i = 0; $i < count($Name); $i++)
    if ( array_key_exists($i, $Media[$M_AUFGABE]) )
      for ($k = 0; $k < count($Media[$M_AUFGABE][$i]); $k++)
      {
        if ( $Media[$M_AUFGABE][$i][$k][3] == -3 )
          $Media[$M_AUFGABE][$i][$k][$indexCollect][2]++;
        else if ( $Media[$M_AUFGABE][$i][$k][3] >= 98 )
          $Media[$M_AUFGABE][$i][$k][$indexCollect][0]++;
        else
          $Media[$M_AUFGABE][$i][$k][$indexCollect][1]++;
      }
}

function ExStateBar($vals, $l, $h)
{
    $s = '';
    $sumAll = 0;
    for ($i = 0; $i < count($vals); $i++)
        $sumAll += $vals[$i];
    $cName = array("gruen", "rot", "blau");
    $cAction = array(get_string('solved_correct', 'stupla'), get_string('solved_wrong', 'stupla'), get_string('unattempted', 'stupla'));
    $pix = 0;
    $sum = 0;
    $s .= '<NOBR>';
    for ($i = 0; $i < count($vals); $i++) {
        if ( $vals[$i] != 0 ) {
            $sum += $vals[$i];
            $sumPix = round($sum*$l/$sumAll);
            $comment = get_string(($vals[$i] == 1) ? 'one_ex_att' : 'mult_ex_att', 'stupla', array('count' => $vals[$i], 'action' => $cAction[$i]));
            $s .= '<img src="col/pc_'.$cName[$i].'.gif" height="'.$h.'" width="'.($sumPix-$pix).'" alt="'.$comment.'" title="'.$comment.'">';
            $pix = $sumPix;
        }
    }
    return $s.'</NOBR>';
}

define("M_TOCMEDIA", 105);
define("M_MEDIAOPEN", 200);

function GetMedia($type, $topic, $i, $what)
{
  global $InTOCMedia, $Media, $sError;
  $m = $type % M_MEDIAOPEN;
  if ( $m >= M_TOCMEDIA )
    $v = $InTOCMedia[$m-M_TOCMEDIA];
  else if ( array_key_exists($m, $Media) && array_key_exists($topic, $Media[$m]) )
    $v = $Media[$m][$topic];
  if ( !empty($v) && array_key_exists($i, $v) && array_key_exists($what, $v[$i]) )
    return $v[$i][$what];
  $sError .= "Error: Media[".$type."][".$topic."][".$i."][".$what."] does not exist.<BR>";
  return "";
}

function PureFileName($s)
{
  $i = strrpos($s, "/");
  $s = ($i == FALSE) ? $s : substr($s, $i+1);
  $i = strrpos($s, ".");
  return ($i == FALSE) ? $s : substr($s, 0, $i);
}

function EnrichNONEGAME1(&$records)
{
	global $curSessionName; // for debug
	$records = array_values($records);

	for ($i = 0; $i < count($records)-1; $i++) {
		if ( substr($records[$i]->data, 0, 11) == '[NONEGAME1]'
			&& substr($records[$i+1]->data, 0, 11) == '[NONEGAME1]'
			&& (strpos($records[$i+1]->data, 'showed') !== FALSE || strpos($records[$i+1]->data, 'overview') )
			&& ($records[$i]->starttime + $records[$i]->duration < $records[$i+1]->starttime - 5
				|| MCPart($records[$i]) != MCPart($records[$i+1]) ) ) {
				$dataNew = str_replace('showed', '****', $records[$i+1]->data);
				$dataNew = str_replace('overview', '****', $dataNew);
				$mcp1 = MCPart($records[$i]);
				$mcp2 = MCPart($records[$i+1]);
				$isConfirm = ($mcp1 != $mcp2);
				$dataNew = str_replace('****', $isConfirm ? '*confirm' : '*hint', $dataNew);
				$result = 0;
				// decide, whether confirm belongs to first ord second $iFine
				if ( $isConfirm ) {
					if ( preg_match('/^\[NONEGAME1\]\[(\d+),([\d\-]+)\]/', $records[$i]->data, $b1) &&
						preg_match('/^\[NONEGAME1\]\[(\d+),([\d\-]+)\]/', $records[$i+1]->data, $b2)) {
							if ( $b1[2] != $b2[2] ) {
								$iFine = $b2[2]+0; // iFine of second
								if ( $b2[1] == 1 )
									$iFine -= 2;
								$c = explode('|', str_replace(' ', '', str_replace('[mc]', '', $mcp2)));
								if ( ($iFine > 0 || $b2[2] == -1) && $c[$iFine*2] == 0 && $c[$iFine*2+1] == 0 ) {
									// belongs to first, so modify the iFine in $dataNew
									//if ( $b2[2] == -1 ) echo "[[debug rk]]";
									$dataNew = str_replace('[NONEGAME1]['.$b2[1].','.$b2[2].']', '[NONEGAME1]['.$b1[1].','.$b1[2].']', $dataNew);
									// and must have been 100%
									if ( $b2[2] != -1 )
										$result = 100;
									else { // last promt in task, so could be "consumed all trials""
										$iRaw = $b1[1]-1;
										$iFine = $b1[2]+0;
										// correction for first task
										if ( $iRaw == 0 )
											$iFine -= 2;
										$correctSolutions = array(
											'[mc]3 | [mc]1 | [mc]2 | [mc]4 | [mc]3 | [mc]2 | [mc]1 | [mc]5 | [mc]1 | [mc]3',
											'[mc]2 | [mc]3 | [mc]2 | [mc]1 | [mc]3 | [mc]4 | [mc]2 | [mc]5 | [mc]3 | [mc]2',
											'[mc]1 | [mc]3 | [mc]2 | [mc]2 | [mc]1 | [mc]1 | [mc]3 | [mc]5 | [mc]2 | [mc]4',
											'[mc]3 | [mc]4 | [mc]2 | [mc]3 | [mc]2 | [mc]2 | [mc]0 | [mc]0 | [mc]0 | [mc]0'); // lst entries missing
										$cCorr = explode('|', str_replace(' ', '', str_replace('[mc]', '', $correctSolutions[$iRaw])));
										$result = ($c[$iFine*2] == $cCorr[$iFine*2] ? 50 : 0) + ($c[$iFine*2+1] == $cCorr[$iFine*2+1] ? 50 : 0);
										//echo "[[debug rk: ", $curSessionName, " ", $iRaw, " ", $result, "]]";
									}
								}
							}
						}
				}
				$reconst = new stdClass;
				$reconst->starttime = $records[$i]->starttime + $records[$i]->duration;
				$reconst->duration = $records[$i+1]->starttime - $reconst->starttime;
				$reconst->stupla = $records[$i]->stupla;
				$reconst->session = $records[$i]->session;
				$reconst->media = $records[$i]->media;
				$reconst->topic = $records[$i]->topic;
				$reconst->nr = $records[$i]->nr;
				$reconst->data = $dataNew;
				$reconst->result = $result;
				array_splice($records, $i+1, 0, array($reconst));
				$i++;
			}
	}
}

function MCPart($entry)
{
	$data1 = $entry->data;
	$j = strpos($data1, '[mc]');
	if ( $j !== FALSE )
		$data1 = substr($data1, $j);
	return $data1;
}

?>